#!/bin/bash
# Created by Min-Kang Hsieh
# calc contact frequency and distance by calling newcontact.tcl

# Set variables for contact map calc 
# d: distance in Angstrom; i: first xtc; f: last xtc
# check psf and xtc files 
# check selected protein "segname PROA" and  "segname PROB"

set d 50 
set i 6
set f 10

set psf ../step5_assembly.psf
for {set k $i} {$k <= $f } {incr k} {
    set xtcFile($k) ../gromacs/step7.${k}_production.xtc; 
    puts $xtcFile($k)
}

# Load the system.
mol load psf $psf

# Loop over the xtc files.
set nFrames0 0
# Load the trajectory.
for {set k $i} {$k <= $f } {incr k} {
    mol addfile $xtcFile($k) type xtc waitfor all
}
set n [molinfo top get numframes]

# calculate contact map 
# usage: fResPair "sel1" "sel2" cutoff <startframe <endframe>>
source newcontacts.tcl
fResPair "segname PROA" "segname PROB" $d 0 $n 

exit

