#!/usr/bin/env python
# created by Min-Kang Hsieh for generation of contact may matrixs

import numpy as np 

num_res=43
num_rows=num_res
num_columns=num_res
num_frame=20006
max_dist=10

def extract_data(filename):
    infile = open(filename, 'r')
    iframe  = []
    residA  = []
    residB  = []
    dist    = []
    for line in infile:
        words = line.split()
        iframe.append(int(words[0]))
        residA.append(int(words[1]))
        residB.append(int(words[4]))
        dist.append(float(words[7]))
    infile.close()
    return iframe, residA, residB, dist 

iframe, residA, residB, dist = extract_data('contact_all.dat')
     
# Creates a list containing residue x residue matrix 
Matrix = np.zeros ((num_rows, num_columns))
MatrixFreq = np.zeros ((num_rows, num_columns))
k = 0
while iframe[k] < num_frame:
   A = residA[k] 
   B = residB[k]-num_res 
   delta=dist[k]/num_frame

   # calc the mean of distance
   Matrix[A,B] += delta 

   # calc the contact frequency
   if dist[k] <= max_dist:
      deltaFreq = 1 
      MatrixFreq[A,B] += deltaFreq  
   #print(k, A, B, Matrix[A,B])  
   k+=1

MatrixFreq = MatrixFreq/num_frame*100 

# Reassign zero contact to max_dist
for i in range(len(Matrix)):
    for j in range(len(Matrix[0])):
        # The confident level of contact is 25% and obove 
        # other data would be screened off and set to max_dist
        if MatrixFreq[i,j] <= 25: 
        # if map would like to show all data without confident level
        # block off the "if MatrixFreq[i,j] <= 25:" and turn on the following if
        #if Matrix[i,j] == 0: 
            Matrix[i,j]=max_dist

# write data to file 
mat = np.matrix(Matrix)
with open('map_distance.dat','wb') as f:
    for line in mat:
        np.savetxt(f, line, fmt='%.2f')

matfreq = np.matrix(MatrixFreq)
with open('map_frequency.dat','wb') as f:
    for linefreq in matfreq:
        np.savetxt(f, linefreq, fmt='%.2f')
